Little script with minicom


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Little script with minicom
# 36  
Old 04-20-2012
Quote:
Originally Posted by Corona688
Yes, just like any other UNIX program or script file.
OK but after if it work how can develop my application Smilie Smilie

I can write 2 script and Monday i test both

thanks but i'm a newbie withscript in linux Smilie
# 37  
Old 04-20-2012
Quote:
Originally Posted by enaud
OK but after if it work how can develop my application Smilie Smilie
I repeat: I see no point in writing dozens lines of code that are nearly guaranteed to fail and you won't be able to fix. It will need fine tuning, and quite probably a complete rewrite, once we find out how differently your non-serial non-modem acts compared to my serial modem.
# 38  
Old 04-23-2012
Hi Corona
I've tested your script with boud rate 9600 but i have this answer:

Bad response
Response was ''

Bad response
Response was ''

I should be OK because i send AT for 2 times..

For you what is the problem?

Thanks
# 39  
Old 04-23-2012
Quote:
Originally Posted by enaud
Thanks but i not undstand where put this function.
Code:
#!/bin/bash
modem=/dev/ttyUSB3
file=/home/giuseppe/Desktop/SCRIPTMODEM/imsi.txt

# print error to stderr and exit unsuccessfully
die() {
    echo "$@" >&2
    exit 1
}

# chat helper. try everything twice.
send_expect() {
    chat -V ABORT ERROR '' "$@" '' || chat -V ABORT ERROR '' "$@" ''
}

# keep modem open, so CD doesn't go low and drop connection
# move terminal to FD3 to avoid redirects on everything else ...
exec 3<&1 >"$modem" <"$modem"

# setup modem options ...
stty 115200

if ! [ -e "$modem" ]; then
    die 'Modem not connected'
fi

if ! send_expect 'AT+CREG?' '+CREG: 0,1'; then
    die 'Modem not registered'
fi

if ! send_expect 'AT!PADSETUP=1,2,82.91.28.127,0,9940,0,1' 'OK'; then
    die 'M2M connection failed'
fi

if ! send_expect 'AT+CGDCONT=1,"IP","web.omnitel.it"' 'OK'; then
    die 'APN setup failed'
fi

if ! send_expect 'AT!PADCONN=1' 'CONNECT'; then
    die 'Unable to open socket'
fi

cat "$file"

# give user idea of success
echo "done" >&3

Quote:
Originally Posted by enaud
you can write complete script pls?
thanks
Totally don't learn anything this way. Smilie you NEED to learn scripting so you can make modifications. such as adding a timeout in the chat command.. adding options to stty to better setup the modem ... changing the APN or M2M destination... etc.

edit: or condensing it and understanding whether you want to, like
Code:
[ -e "$modem" ] || die 'Modem not connected'
send_expect 'AT+CREG?' '+CREG: 0,1' || die 'Modem not registered'
send_expect 'AT!PADSETUP=1,2,82.91.28.127,0,9940,0,1' 'OK' || die 'M2M connection failed'
send_expect 'AT+CGDCONT=1,"IP","web.omnitel.it"' 'OK' || die 'APN setup failed'
send_expect 'AT!PADCONN=1' 'CONNECT' || die 'Unable to open socket'

Smilie

Last edited by neutronscott; 04-23-2012 at 03:23 PM.. Reason: fixed chat options and arguments!
These 2 Users Gave Thanks to neutronscott For This Post:
# 40  
Old 04-23-2012
Quote:
Originally Posted by enaud
Hi Corona
I've tested your script with boud rate 9600 but i have this answer:

Bad response
Response was ''

Bad response
Response was ''

I should be OK because i send AT for 2 times..

For you what is the problem?
I really don't know and can't tell from here. You may have to keep fiddling with stty until communication with the modem is established. I don't even know if your modem responds quite like mine does. Perhaps 'chat' will work better for you, as well.

Last edited by Corona688; 04-23-2012 at 02:36 PM..
This User Gave Thanks to Corona688 For This Post:
# 41  
Old 04-23-2012
Quote:
Originally Posted by Corona688
I really don't know and can't tell from here. You may have to keep fiddling with stty until communication with the modem is established. I don't even know if your modem responds quite like mine does. Perhaps 'chat' will work better for you, as well.
ok thanks Smilie

---------- Post updated at 01:00 PM ---------- Previous update was at 12:57 PM ----------

Quote:
Originally Posted by neutronscott
Code:
#!/bin/bash
modem=/dev/ttyUSB3
file=/home/giuseppe/Desktop/SCRIPTMODEM/imsi.txt

# print error to stderr and exit unsuccessfully
die() {
    echo "$@" >&2
    exit 1
}

# chat helper. try everything twice.
send_expect() {
    chat -v -f 'ABORT ERROR' '' "$@" '' || chat -v -f 'ABORT ERROR' '' "$@" ''
}

# keep modem open, so CD doesn't go low and drop connection
# move terminal to FD3 to avoid redirects on everything else ...
exec 3<&1 >"$modem" <"$modem"

# setup modem options ...
stty 115200

if ! [ -e "$modem" ]; then
    die 'Modem not connected'
fi

if ! send_expect 'AT+CREG?' '+CREG: 0,1'; then
    die 'Modem not registered'
fi

if ! send_expect 'AT!PADSETUP=1,2,82.91.28.127,0,9940,0,1' 'OK'; then
    die 'M2M connection failed'
fi

if ! send_expect 'AT+CGDCONT=1,"IP","web.omnitel.it"' 'OK'; then
    die 'APN setup failed'
fi

if ! send_expect 'AT!PADCONN=1' 'CONNECT'; then
    die 'Unable to open socket'
fi

cat "$file"

# give user idea of success
echo "done" >&3

Totally don't learn anything this way. Smilie you NEED to learn scripting so you can make modifications. such as adding a timeout in the chat command.. adding options to stty to better setup the modem ... changing the APN or M2M destination... etc.

edit: or condensing it and understanding whether you want to, like
Code:
[ -e "$modem" ] || die 'Modem not connected'
send_expect 'AT+CREG?' '+CREG: 0,1' || die 'Modem not registered'
send_expect 'AT!PADSETUP=1,2,82.91.28.127,0,9940,0,1' 'OK' || die 'M2M connection failed'
send_expect 'AT+CGDCONT=1,"IP","web.omnitel.it"' 'OK' || die 'APN setup failed'
send_expect 'AT!PADCONN=1' 'CONNECT' || die 'Unable to open socket'

Smilie
Thanks You are very kind and very good..
i've doing this and with stty 115200 i have error on stty but if i put stty 9600 i have this error:

Code:
giuseppe@ubuntu:~/Scrivania/SCRIPTMODEM$ ./modem2.sh
Usage: chat [-e] [-E] [-v] [-V] [-t timeout] [-r report-file]
     [-T phone-number] [-U phone-number2] {-f chat-file | chat-script}
Usage: chat [-e] [-E] [-v] [-V] [-t timeout] [-r report-file]
     [-T phone-number] [-U phone-number2] {-f chat-file | chat-script}
Modem not registered

i've also put stty 9600 -clocal cs8 -parenb -cstopb for to have 8n1 but why i cant put 115200?

for timeout I insert sleep (2) for example but where in your script? Perphas:

if ! send_expect 'AT+CGDCONT=1,"IP","web.omnitel.it"' 'OK' sleep(2); then
die 'APN setup failed'
fi

is right?
thanks
# 42  
Old 04-23-2012
You've been asking over and over about the stty error. We cannot know, we don't have this driver. It's very possible you cannot change the baud rate. Just forget that for now if it works.

The chat error is that I accidently copied the wrong line. Remove the -f and change the -v to -V like we had before.
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. UNIX for Dummies Questions & Answers

Alternatives to minicom During Remote Access?

Hey All, I am trying to find something similar to minicom, but it needs the ability to be ran during a remote dialup session on the remote device's side. If I dial into the remote server (*using minicom) and then try to run minicom on the remote server I get the following: # minicom... (20 Replies)
Discussion started by: mrm5102
20 Replies

2. SCO

Minicom

hello is there a copy of minicom or equivalent for unixware 7? thanks (3 Replies)
Discussion started by: deus-programmer
3 Replies

3. Shell Programming and Scripting

Expect script not working in crontab with minicom

Hi All, I am testing expect script in command prompt without issue, but in crontab it is not working, i check the output error as below: #cat /var/log/testexp.log spawn minicom -C /var/log/minicom1.log No cursor motion capability (cm) AT+COPS=? I am new in scripting, together... (1 Reply)
Discussion started by: elingtey
1 Replies

4. Shell Programming and Scripting

Help with minicom script

I'm a fairly new user to Linux based systems and am still a little uncomfortable with using the command interface. I'm trying to get my feet wet but have unfortunately hit a wall and am actually not even sure what I am trying to accomplish is at all possible. Basically, I am trying to use a... (0 Replies)
Discussion started by: nrdk00
0 Replies

5. Shell Programming and Scripting

Exiting from Minicom on a shell script

This is what I've tried: #!/bin/sh send sh send showifs send exit ! killall minicom My problem is that for some reason when I do this it doesn't give me the results of the prior commands sent like showifs So I suspect my syntax is wrong. (1 Reply)
Discussion started by: uradunce
1 Replies

6. Shell Programming and Scripting

minicom works, but stty does not

Hi all, I have some trouble getting stty to talk to some serial/usb converter. Getting minicom to work was however quite simple after I entered the following settings in addition to its standard-setup: pu port /dev/ttyUSB0 pu baudrate 19200 pu bits 8 pu... (3 Replies)
Discussion started by: pa-trick
3 Replies

7. Shell Programming and Scripting

expect minicom

Hi, I am new to using minicom. I want how to write a expect script for minicom login? I wrote a code but its not acting what iam expecting. here I have my code: #!/usr/bin/expect set fd fconfigure $fd spawn -open $fd spawn minicom expect “enter:” send "\n" send "\n" ... (3 Replies)
Discussion started by: vanid
3 Replies

8. Shell Programming and Scripting

running scripts in minicom

Hi, I am new to use minicom. I want script to run on minicom with username and password as automated.(Expect). please could anyone suggest the sample code for it. Thanks in advance (2 Replies)
Discussion started by: vanid
2 Replies

9. UNIX for Dummies Questions & Answers

Minicom Scripting

Does anyone have a working minicom script they would care to post as I can't get the scripting working and the scriptdemo and unixlogin sample scripts are on my system either. Thanx, I (2 Replies)
Discussion started by: ianf
2 Replies

10. UNIX for Dummies Questions & Answers

linux - minicom

hello. i'm attempting to use minicom in linux, but i'm having some difficulties. When i type in "minicom", the application opens up. It says 'starting minicom/finding modem'(something like that). However, once it actually starts, I can't do anything. No matter what I type in, it doesn't work. ... (2 Replies)
Discussion started by: kickboxer
2 Replies
Login or Register to Ask a Question